Attribute VB_Name = "mdlChooseColorEx"
Option Explicit

'Rs[
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)

'RGBlێ\
Private Type RGBQUAD
    R As Byte
    G As Byte
    B As Byte
    P As Byte
End Type
Private udtRGB(15) As RGBQUAD

Private Type CHOOSE_COLOR
    lStructSize As Long   '̍\̂̃TCY
    hWndOwner As Long     'eEChEnh
    hInstance As Long     'CX^X
    rgbResult As Long     'IRGBl
    lpCustColors As Long  'JX^J[zւ̃|C^
    flags As Long         'wtO
    lCustData As Long     'JX^_CAOւ̃f[^
    lpfnHook As Long      'tbN֐ւ̃|C^
    lpTemplateName As String   '???
End Type

'[F̐ݒ]R_CAO\
Private Declare Function ChooseColor Lib "comdlg32" Alias "ChooseColorA" (ByRef pChoosecolor As CHOOSE_COLOR) As Long

Private Const CC_RGBINIT = &H1         '_CAO{bNX̐F̏lݒ肷
Private Const CC_FULLOPEN = &H2        'F̍쐬s\
Private Const CC_PREVENTFULLOPEN = &H4 '_CAO{bNX [F̍쐬]{^𖳌ɂ
Private Const CC_SHOWHELP = &H8        'wv{^\
Private Const CC_ENABLEHOOK = &H10     'lpfnHoolŎw肳ꂽtbN֐Lɂ
Private Const CC_ANYCOLOR = &H100&     'ǂȐFׂĕ\

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Const WS_CHILD = &H40000000
Private Const WS_VISIBLE = &H10000000
Private Const BS_PUSHBUTTON = &H0&

'EBhE쐬
Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
'쐬EBhEj
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long

Private Const WM_INITDIALOG = &H110
Private Const WM_COMMAND = &H111

'EBhEړ
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long

'EBhË̗擾
Private Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

'Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long

'EBhEɕ擾Eݒ肷
Private Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long
Private Declare Function SetWindowText Lib "user32" Alias "SetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String) As Long

'_CAOEBhEIDɑ΂IuWFNg̕擾
Private Declare Function GetDlgItemText Lib "user32" Alias "GetDlgItemTextA" (ByVal hDlg As Long, ByVal nIDDlgItem As Long, ByVal lpString As String, ByVal nMaxCount As Long) As Long

'NXALvVEChEnh𓾂
Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

'Ǝɒǉ{^̃EBhEnh
Private m_hButton As Long

Private Const ID_OK = 1
Private Const ID_CANCEL = 2
Private Const ID_MY_BUTTON As Long = 70

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \F Chr$(0)[=vbNullChar] ܂Ŏ擾
'   F(i)SrcStr c Ώە
' ԂlFҏWꂽ
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Private Function StrNullCut(ByVal SrcStr As String) As String
    Dim NullCharPos As Integer
    NullCharPos = InStr(SrcStr, Chr$(0))
    If NullCharPos = 0 Then
        StrNullCut = SrcStr
        Exit Function
    End If
    StrNullCut = Left$(SrcStr, NullCharPos - 1)
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FtbN֐̃AhX擾
'   F(i) lngAddressOfFunc c tbN֐̃AhX
' ԂlFtbN֐̃AhX
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Private Function GetFunctionAddress(ByVal lngAddressOfFunc As Long) As Long
    GetFunctionAddress = lngAddressOfFunc
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \F[F̐ݒ]R_CAÕtbN֐
'   F(i) hwnd c [F̐ݒ]R_CAÕEBhEnh
' ԂlF擾F   [LZ]{^ꂽꍇ-1Ԃ
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function GetColorEx(ByVal hwnd As Long) As Long
    Dim udtCC As CHOOSE_COLOR
    Dim FuncRet As Boolean
    Dim i As Long
    Static IsUsed As Boolean

    '16ƎFݒg̏̐F𔒂ɐݒ肷
    If IsUsed = False Then
        For i = 0 To 15
             With udtRGB(i)
                 .R = 255: .G = 255: .B = 255
             End With
        Next i
        IsUsed = True
    End If

    With udtCC
        .lStructSize = Len(udtCC)
        .hWndOwner = hwnd
        .hInstance = App.hInstance
        .lpCustColors = VarPtr(udtRGB(0))
        .lpfnHook = GetFunctionAddress(AddressOf CCHookProc)
        .flags = CC_RGBINIT Or CC_ANYCOLOR Or CC_FULLOPEN Or CC_ENABLEHOOK
    End With

    '[F̐ݒ]_CAO\
    FuncRet = ChooseColor(udtCC)
    If FuncRet Then
        GetColorEx = udtCC.rgbResult
        Call CopyMemory(udtRGB(0), ByVal udtCC.lpCustColors, Len(udtCC) * 16)
    Else
        GetColorEx = -1
    End If

End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \F_CAOIDɑ΂l擾
'   F(i)hwnd     c _CAO{bNX̃EBhEnh
'         (i)TargetID c _CAO{bNX̃Rg[ID
' ԂlF0Ԃ
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Private Function GetDialogIDValue(ByVal hwnd As Long, ByVal TargetID As Long)
    Dim Buffer As String
    Buffer = String$(120, Chr$(0))
    Call GetDlgItemText(hwnd, TargetID, Buffer, 120)
    GetDialogIDValue = StrNullCut(Buffer)
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FFI擾
'   F(i)hwnd   c EChnh
'         (i)uMsg   c EChEbZ[W
'         (i)wParam c ǉP
'         (i)lParam c ǉQ
' ԂlF0Ԃ
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Function CCHookProc(ByVal hwnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Select Case uMsg
        'R_CAOꂽ
        Case WM_INITDIALOG
            Dim udtRect As RECT
            Dim hOKButton As Long

            'EBhE\ʒuTCY𒲐
            Call GetWindowRect(hwnd, udtRect)
            With udtRect
                'Call MoveWindow(hwnd, .Left, .Top, .Right - .Left, .Bottom - .Top + 60, Abs(CLng(True)))
                Call MoveWindow(hwnd, .Left + 20, .Top + 20, .Right - .Left, .Bottom - .Top + 60, Abs(CLng(True)))
            End With

            '{^쐬
            m_hButton = CreateWindowEx(0, "BUTTON", "ςȃ{^H", WS_CHILD Or WS_VISIBLE Or BS_PUSHBUTTON, _
                                     300, udtRect.Bottom - udtRect.Top - 5, 200, 30, _
                                     hwnd, ID_MY_BUTTON, App.hInstance, ByVal 0&)
            Debug.Print "? m_hButton : " & m_hButton

            'EBhE^CgύX
            Call SetWindowText(hwnd, "F̐ݒ - Ɋg!!" & Chr$(0))

            '[OK]{^̃LvVύX
            hOKButton = FindWindowEx(hwnd, 0&, vbNullString, "OK" & Chr$(0))
            Call SetWindowText(hOKButton, "!!" & Chr$(0))
        'R}hsꂽ
        Case WM_COMMAND
            Select Case wParam
                Case ID_OK, ID_CANCEL  '[OK][LZ]{^ꂽ
                    '{^j
                    Call DestroyWindow(m_hButton)
                Case ID_MY_BUTTON      '{^
                    Dim MsgBoxText As String
                    Dim i As Long
                    Const ID_LABEL As Long = &H2D3
                    Const ID_TEXTBOX As Long = &H2BF
                    For i = 0 To 5
                        MsgBoxText = MsgBoxText & GetDialogIDValue(hwnd, ID_LABEL + i)
                        MsgBoxText = MsgBoxText & "F"
                        MsgBoxText = MsgBoxText & GetDialogIDValue(hwnd, ID_TEXTBOX + i)
                        MsgBoxText = MsgBoxText & vbCrLf
                    Next i
                    MsgBoxText = MsgBoxText & vbCrLf
                    MsgBoxText = MsgBoxText & "ςȃ{^F" & GetDialogIDValue(hwnd, &H2C9)
                    Call MsgBox(MsgBoxText, vbOKOnly + vbInformation, "l擾܂")

                    '܂ ܂ ܂ ܂ ܂
                    'Dim ObjCaption As String
                    'Debug.Print "=========================================="
                    'For i = 0 To 65535
                    '    ObjCaption = GetDialogIDValue(hwnd, i)
                    '    If Len(ObjCaption) > 0 Then Debug.Print "? &H" & UCase$(Hex$(i)) & " F " & ObjCaption
                    'Next i
                    'Debug.Print "=========================================="
                Case &H2C9             'ςȉB{^H
                    Call MsgBox("B{^܂!!")
            End Select
    End Select
End Function

'-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
' @  \FRGBlRGBQUAD\̂ɓWJ
'   F(i)RGBValue c RGBl
'         (i/o)R      c Rl
'         (i/o)G      c Gl
'         (i/o)B      c Bl
' ԂlFȂ
'=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
Public Sub RGB2RGBQuad(ByVal RGBValue As Long, _
                       ByRef R As Byte, ByRef G As Byte, ByRef B As Byte)
    R = RGBValue And &HFF
    G = (RGBValue And &HFF00&) \ &H100&
    B = (RGBValue And &HFF0000) \ &H10000
End Sub
